import {getDataSet, getEventParam} from "../../../../utils/utils";

Component({
    properties: {
        show: Boolean,
        advantageData: Array,
        advantageIds: String,
    },
    observers: {
        advantageIds: function (newV) {
            if (newV) {
                let values = newV.split(",");
                const arr = [];
                values.forEach(item => {
                    const text = this.data.advantageData.find(text => {
                        return text.dictValue == item;
                    })
                    if (text) {
                        arr.push(text.dictLabel);
                    }
                })
                this.setData({result: values, advantage: arr.join(",")})
            }else{
                this.setData({result: [], advantage:""})
            }
        }
    },
    data: {
        advantage: '',
        result: [],
    },
    methods: {
        close(e) {
            this.setData({
                show: false
            })
        },
        onChange(e) {
            let data = getEventParam(e);
            console.log("check",data)
            this.setData({
                advantageIds: data.join(",")
            },()=>{
                this.triggerEvent("change", {
                    'formData.advantage': this.data.advantageIds,
                })
            })
        },
        bindAdvantageChange() {
            this.setData({
                show: true,
            })
        },
        toggle(event) {
            const {index} = getDataSet(event);
            const checkbox = this.selectComponent(`.checkboxes-${index}`);
            checkbox.toggle();
        },
        noop() {
        }
    }
});
